| # -*-Makefile-*- |
| # This Makefile fragment tries to be general-purpose enough to be |
| # used by many projects via the gnulib maintainer-makefile module. |
| |
| ## Copyright (C) 2001-2011 Free Software Foundation, Inc. |
| ## |
| ## This program is free software: you can redistribute it and/or modify |
| ## it under the terms of the GNU General Public License as published by |
| ## the Free Software Foundation, either version 3 of the License, or |
| ## (at your option) any later version. |
| ## |
| ## This program is distributed in the hope that it will be useful, |
| ## but WITHOUT ANY WARRANTY; without even the implied warranty of |
| ## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the |
| ## GNU General Public License for more details. |
| ## |
| ## You should have received a copy of the GNU General Public License |
| ## along with this program. If not, see <http://www.gnu.org/licenses/>. |
| |
| # This is reported not to work with make-3.79.1 |
| # ME := $(word $(words $(MAKEFILE_LIST)),$(MAKEFILE_LIST)) |
| ME := maint.mk |
| |
| # Override this in cfg.mk if you use a non-standard build-aux directory. |
| build_aux ?= $(srcdir)/build-aux |
| |
| # Do not save the original name or timestamp in the .tar.gz file. |
| # Use --rsyncable if available. |
| gzip_rsyncable := \ |
| $(shell gzip --help 2>/dev/null|grep rsyncable >/dev/null \ |
| && printf %s --rsyncable) |
| GZIP_ENV = '--no-name --best $(gzip_rsyncable)' |
| |
| GIT = git |
| VC = $(GIT) |
| VC-tag = git tag -s -m '$(VERSION)' -u '$(gpg_key_ID)' |
| |
| VC_LIST = $(build_aux)/vc-list-files -C $(srcdir) |
| |
| # You can override this variable in cfg.mk to set your own regexp |
| # matching files to ignore. |
| VC_LIST_ALWAYS_EXCLUDE_REGEX ?= ^$$ |
| |
| # This is to preprocess robustly the output of $(VC_LIST), so that even |
| # when $(srcdir) is a pathological name like "....", the leading sed command |
| # removes only the intended prefix. |
| _dot_escaped_srcdir = $(subst .,\.,$(srcdir)) |
| |
| # Post-process $(VC_LIST) output, prepending $(srcdir)/, but only |
| # when $(srcdir) is not ".". |
| ifeq ($(srcdir),.) |
| _prepend_srcdir_prefix = |
| else |
| _prepend_srcdir_prefix = | sed 's|^|$(srcdir)/|' |
| endif |
| |
| # In order to be able to consistently filter "."-relative names, |
| # (i.e., with no $(srcdir) prefix), this definition is careful to |
| # remove any $(srcdir) prefix, and to restore what it removes. |
| VC_LIST_EXCEPT = \ |
| $(VC_LIST) | sed 's|^$(_dot_escaped_srcdir)/||' \ |
| | if test -f $(srcdir)/.x-$@; then grep -vEf $(srcdir)/.x-$@; \ |
| else grep -Ev -e "$${VC_LIST_EXCEPT_DEFAULT-ChangeLog}"; fi \ |
| | grep -Ev -e '$(VC_LIST_ALWAYS_EXCLUDE_REGEX)' \ |
| $(_prepend_srcdir_prefix) |
| |
| ifeq ($(origin prev_version_file), undefined) |
| prev_version_file = $(srcdir)/.prev-version |
| endif |
| |
| PREV_VERSION := $(shell cat $(prev_version_file) 2>/dev/null) |
| VERSION_REGEXP = $(subst .,\.,$(VERSION)) |
| PREV_VERSION_REGEXP = $(subst .,\.,$(PREV_VERSION)) |
| |
| ifeq ($(VC),$(GIT)) |
| this-vc-tag = v$(VERSION) |
| this-vc-tag-regexp = v$(VERSION_REGEXP) |
| else |
| tag-package = $(shell echo "$(PACKAGE)" | tr '[:lower:]' '[:upper:]') |
| tag-this-version = $(subst .,_,$(VERSION)) |
| this-vc-tag = $(tag-package)-$(tag-this-version) |
| this-vc-tag-regexp = $(this-vc-tag) |
| endif |
| my_distdir = $(PACKAGE)-$(VERSION) |
| |
| # Old releases are stored here. |
| release_archive_dir ?= ../release |
| |
| # Override gnu_rel_host and url_dir_list in cfg.mk if these are not right. |
| # Use alpha.gnu.org for alpha and beta releases. |
| # Use ftp.gnu.org for stable releases. |
| gnu_ftp_host-alpha = alpha.gnu.org |
| gnu_ftp_host-beta = alpha.gnu.org |
| gnu_ftp_host-stable = ftp.gnu.org |
| gnu_rel_host ?= $(gnu_ftp_host-$(RELEASE_TYPE)) |
| |
| ifeq ($(gnu_rel_host),ftp.gnu.org) |
| url_dir_list ?= http://ftpmirror.gnu.org/$(PACKAGE) |
| else |
| url_dir_list ?= ftp://$(gnu_rel_host)/gnu/$(PACKAGE) |
| endif |
| |
| # Override this in cfg.mk if you are using a different format in your |
| # NEWS file. |
| today = $(shell date +%Y-%m-%d) |
| |
| # Select which lines of NEWS are searched for $(news-check-regexp). |
| # This is a sed line number spec. The default says that we search |
| # lines 1..10 of NEWS for $(news-check-regexp). |
| # If you want to search only line 3 or only lines 20-22, use "3" or "20,22". |
| news-check-lines-spec ?= 1,10 |
| news-check-regexp ?= '^\*.* $(VERSION_REGEXP) \($(today)\)' |
| |
| # Prevent programs like 'sort' from considering distinct strings to be equal. |
| # Doing it here saves us from having to set LC_ALL elsewhere in this file. |
| export LC_ALL = C |
| |
| ## --------------- ## |
| ## Sanity checks. ## |
| ## --------------- ## |
| |
| _cfg_mk := $(shell test -f $(srcdir)/cfg.mk && echo '$(srcdir)/cfg.mk') |
| |
| # Collect the names of rules starting with `sc_'. |
| syntax-check-rules := $(sort $(shell sed -n 's/^\(sc_[a-zA-Z0-9_-]*\):.*/\1/p' \ |
| $(srcdir)/$(ME) $(_cfg_mk))) |
| .PHONY: $(syntax-check-rules) |
| |
| local-checks-available = \ |
| $(syntax-check-rules) |
| .PHONY: $(local-checks-available) |
| |
| # Arrange to print the name of each syntax-checking rule just before running it. |
| $(syntax-check-rules): %: %.m |
| sc_m_rules_ = $(patsubst %, %.m, $(syntax-check-rules)) |
| .PHONY: $(sc_m_rules_) |
| $(sc_m_rules_): |
| @echo $(patsubst sc_%.m, %, $@) |
| @date +%s.%N > .sc-start-$(basename $@) |
| |
| # Compute and print the elapsed time for each syntax-check rule. |
| sc_z_rules_ = $(patsubst %, %.z, $(syntax-check-rules)) |
| .PHONY: $(sc_z_rules_) |
| $(sc_z_rules_): %.z: % |
| @end=$$(date +%s.%N); \ |
| start=$$(cat .sc-start-$*); \ |
| rm -f .sc-start-$*; \ |
| awk -v s=$$start -v e=$$end \ |
| 'END {printf "%.2f $(patsubst sc_%,%,$*)\n", e - s}' < /dev/null |
| |
| # The patsubst here is to replace each sc_% rule with its sc_%.z wrapper |
| # that computes and prints elapsed time. |
| local-check := \ |
| $(patsubst sc_%, sc_%.z, \ |
| $(filter-out $(local-checks-to-skip), $(local-checks-available))) |
| |
| syntax-check: $(local-check) |
| |
| # _sc_search_regexp |
| # |
| # This macro searches for a given construct in the selected files and |
| # then takes some action. |
| # |
| # Parameters (shell variables): |
| # |
| # prohibit | require |
| # |
| # Regular expression (ERE) denoting either a forbidden construct |
| # or a required construct. Those arguments are exclusive. |
| # |
| # in_vc_files | in_files |
| # |
| # grep-E-style regexp denoting the files to check. If no files |
| # are specified the default are all the files that are under |
| # version control. |
| # |
| # containing | non_containing |
| # |
| # Select the files (non) containing strings matching this regexp. |
| # If both arguments are specified then CONTAINING takes |
| # precedence. |
| # |
| # with_grep_options |
| # |
| # Extra options for grep. |
| # |
| # ignore_case |
| # |
| # Ignore case. |
| # |
| # halt |
| # |
| # Message to display before to halting execution. |
| |
| # By default, _sc_search_regexp does not ignore case. |
| export ignore_case = |
| _ignore_case = $$(test -n "$$ignore_case" && printf %s -i || :) |
| |
| define _sc_say_and_exit |
| dummy=; : so we do not need a semicolon before each use; \ |
| { printf '%s\n' "$(ME): $$msg" 1>&2; exit 1; }; |
| endef |
| |
| # _sc_search_regexp used to be named _prohibit_regexp. However, |
| # upgrading to the new definition and leaving the old name undefined |
| # would usually convert each custom rule using $(_prohibit_regexp) |
| # (usually defined in cfg.mk) into a no-op. This definition ensures |
| # that people know right away if they're still using the old name. |
| # FIXME: remove in 2012. |
| _prohibit_regexp = \ |
| $(error '*** you need to s/_prohibit_regexp/_sc_search_regexp/, and adapt') |
| |
| define _sc_search_regexp |
| dummy=; : so we do not need a semicolon before each use; \ |
| \ |
| : Check arguments; \ |
| test -n "$$prohibit" && test -n "$$require" \ |
| && { msg='Cannot specify both prohibit and require' \ |
| $(_sc_say_and_exit) } || :; \ |
| test -z "$$prohibit" && test -z "$$require" \ |
| && { msg='Should specify either prohibit or require' \ |
| $(_sc_say_and_exit) } || :; \ |
| test -n "$$in_vc_files" && test -n "$$in_files" \ |
| && { msg='Cannot specify both in_vc_files and in_files' \ |
| $(_sc_say_and_exit) } || :; \ |
| test "x$$halt" != x \ |
| || { msg='halt not defined' $(_sc_say_and_exit) }; \ |
| \ |
| : Filter by file name; \ |
| if test -n "$$in_files"; then \ |
| files=$$(find $(srcdir) | grep -E "$$in_files"); \ |
| else \ |
| files=$$($(VC_LIST_EXCEPT)); \ |
| if test -n "$$in_vc_files"; then \ |
| files=$$(echo "$$files" | grep -E "$$in_vc_files"); \ |
| fi; \ |
| fi; \ |
| \ |
| : Filter by content; \ |
| test -n "$$files" && test -n "$$containing" \ |
| && { files=$$(grep -l "$$containing" $$files); } || :; \ |
| test -n "$$files" && test -n "$$non_containing" \ |
| && { files=$$(grep -vl "$$non_containing" $$files); } || :; \ |
| \ |
| : Check for the construct; \ |
| if test -n "$$files"; then \ |
| if test -n "$$prohibit"; then \ |
| grep $$with_grep_options $(_ignore_case) -nE "$$prohibit" $$files \ |
| && { msg="$$halt" $(_sc_say_and_exit) } || :; \ |
| else \ |
| grep $$with_grep_options $(_ignore_case) -LE "$$require" $$files \ |
| | grep . \ |
| && { msg="$$halt" $(_sc_say_and_exit) } || :; \ |
| fi \ |
| else :; \ |
| fi || :; |
| endef |
| |
| sc_avoid_if_before_free: |
| @$(build_aux)/useless-if-before-free \ |
| $(useless_free_options) \ |
| $$($(VC_LIST_EXCEPT) | grep -v useless-if-before-free) && \ |
| { echo '$(ME): found useless "if" before "free" above' 1>&2; \ |
| exit 1; } || : |
| |
| sc_cast_of_argument_to_free: |
| @prohibit='\<free *\( *\(' halt='don'\''t cast free argument' \ |
| $(_sc_search_regexp) |
| |
| sc_cast_of_x_alloc_return_value: |
| @prohibit='\*\) *x(m|c|re)alloc\>' \ |
| halt='don'\''t cast x*alloc return value' \ |
| $(_sc_search_regexp) |
| |
| sc_cast_of_alloca_return_value: |
| @prohibit='\*\) *alloca\>' \ |
| halt='don'\''t cast alloca return value' \ |
| $(_sc_search_regexp) |
| |
| sc_space_tab: |
| @prohibit='[ ] ' \ |
| halt='found SPACE-TAB sequence; remove the SPACE' \ |
| $(_sc_search_regexp) |
| |
| # Don't use *scanf or the old ato* functions in `real' code. |
| # They provide no error checking mechanism. |
| # Instead, use strto* functions. |
| sc_prohibit_atoi_atof: |
| @prohibit='\<([fs]?scanf|ato([filq]|ll)) *\(' \ |
| halt='do not use *scan''f, ato''f, ato''i, ato''l, ato''ll or ato''q' \ |
| $(_sc_search_regexp) |
| |
| # Use STREQ rather than comparing strcmp == 0, or != 0. |
| sc_prohibit_strcmp: |
| @grep -nE '! *str''cmp *\(|\<str''cmp *\(.+\) *[!=]=' \ |
| $$($(VC_LIST_EXCEPT)) \ |
| | grep -vE ':# *define STRN?EQ\(' && \ |
| { echo '$(ME): replace str''cmp calls above with STREQ/STRNEQ' \ |
| 1>&2; exit 1; } || : |
| |
| # Pass EXIT_*, not number, to usage, exit, and error (when exiting) |
| # Convert all uses automatically, via these two commands: |
| # git grep -l '\<exit *(1)' \ |
| # | grep -vEf .x-sc_prohibit_magic_number_exit \ |
| # | xargs --no-run-if-empty \ |
| # perl -pi -e 's/(^|[^.])\b(exit ?)\(1\)/$1$2(EXIT_FAILURE)/' |
| # git grep -l '\<exit *(0)' \ |
| # | grep -vEf .x-sc_prohibit_magic_number_exit \ |
| # | xargs --no-run-if-empty \ |
| # perl -pi -e 's/(^|[^.])\b(exit ?)\(0\)/$1$2(EXIT_SUCCESS)/' |
| sc_prohibit_magic_number_exit: |
| @prohibit='(^|[^.])\<(usage|exit) ?\([0-9]|\<error ?\([1-9][0-9]*,' \ |
| halt='use EXIT_* values rather than magic number' \ |
| $(_sc_search_regexp) |
| |
| # Using EXIT_SUCCESS as the first argument to error is misleading, |
| # since when that parameter is 0, error does not exit. Use `0' instead. |
| sc_error_exit_success: |
| @prohibit='error *\(EXIT_SUCCESS,' \ |
| in_vc_files='\.[chly]$$' \ |
| halt='found error (EXIT_SUCCESS' \ |
| $(_sc_search_regexp) |
| |
| # `FATAL:' should be fully upper-cased in error messages |
| # `WARNING:' should be fully upper-cased, or fully lower-cased |
| sc_error_message_warn_fatal: |
| @grep -nEA2 '[^rp]error *\(' $$($(VC_LIST_EXCEPT)) \ |
| | grep -E '"Warning|"Fatal|"fatal' && \ |
| { echo '$(ME): use FATAL, WARNING or warning' 1>&2; \ |
| exit 1; } || : |
| |
| # Error messages should not start with a capital letter |
| sc_error_message_uppercase: |
| @grep -nEA2 '[^rp]error *\(' $$($(VC_LIST_EXCEPT)) \ |
| | grep -E '"[A-Z]' \ |
| | grep -vE '"FATAL|"WARNING|"Java|"C#|PRIuMAX' && \ |
| { echo '$(ME): found capitalized error message' 1>&2; \ |
| exit 1; } || : |
| |
| # Error messages should not end with a period |
| sc_error_message_period: |
| @grep -nEA2 '[^rp]error *\(' $$($(VC_LIST_EXCEPT)) \ |
| | grep -E '[^."]\."' && \ |
| { echo '$(ME): found error message ending in period' 1>&2; \ |
| exit 1; } || : |
| |
| sc_file_system: |
| @prohibit=file''system \ |
| ignore_case=1 \ |
| halt='found use of "file''system"; spell it "file system"' \ |
| $(_sc_search_regexp) |
| |
| # Don't use cpp tests of this symbol. All code assumes config.h is included. |
| sc_prohibit_have_config_h: |
| @prohibit='^# *if.*HAVE''_CONFIG_H' \ |
| halt='found use of HAVE''_CONFIG_H; remove' \ |
| $(_sc_search_regexp) |
| |
| # Nearly all .c files must include <config.h>. However, we also permit this |
| # via inclusion of a package-specific header, if cfg.mk specified one. |
| # config_h_header must be suitable for grep -E. |
| config_h_header ?= <config\.h> |
| sc_require_config_h: |
| @require='^# *include $(config_h_header)' \ |
| in_vc_files='\.c$$' \ |
| halt='the above files do not include <config.h>' \ |
| $(_sc_search_regexp) |
| |
| # You must include <config.h> before including any other header file. |
| # This can possibly be via a package-specific header, if given by cfg.mk. |
| sc_require_config_h_first: |
| @if $(VC_LIST_EXCEPT) | grep -l '\.c$$' > /dev/null; then \ |
| fail=0; \ |
| for i in $$($(VC_LIST_EXCEPT) | grep '\.c$$'); do \ |
| grep '^# *include\>' $$i | sed 1q \ |
| | grep -E '^# *include $(config_h_header)' > /dev/null \ |
| || { echo $$i; fail=1; }; \ |
| done; \ |
| test $$fail = 1 && \ |
| { echo '$(ME): the above files include some other header' \ |
| 'before <config.h>' 1>&2; exit 1; } || :; \ |
| else :; \ |
| fi |
| |
| sc_prohibit_HAVE_MBRTOWC: |
| @prohibit='\bHAVE_MBRTOWC\b' \ |
| halt="do not use $$prohibit; it is always defined" \ |
| $(_sc_search_regexp) |
| |
| # To use this "command" macro, you must first define two shell variables: |
| # h: the header, enclosed in <> or "" |
| # re: a regular expression that matches IFF something provided by $h is used. |
| define _sc_header_without_use |
| dummy=; : so we do not need a semicolon before each use; \ |
| h_esc=`echo "$$h"|sed 's/\./\\\\./g'`; \ |
| if $(VC_LIST_EXCEPT) | grep -l '\.c$$' > /dev/null; then \ |
| files=$$(grep -l '^# *include '"$$h_esc" \ |
| $$($(VC_LIST_EXCEPT) | grep '\.c$$')) && \ |
| grep -LE "$$re" $$files | grep . && \ |
| { echo "$(ME): the above files include $$h but don't use it" \ |
| 1>&2; exit 1; } || :; \ |
| else :; \ |
| fi |
| endef |
| |
| # Prohibit the inclusion of assert.h without an actual use of assert. |
| sc_prohibit_assert_without_use: |
| @h='<assert.h>' re='\<assert *\(' $(_sc_header_without_use) |
| |
| # Prohibit the inclusion of close-stream.h without an actual use. |
| sc_prohibit_close_stream_without_use: |
| @h='"close-stream.h"' re='\<close_stream *\(' $(_sc_header_without_use) |
| |
| # Prohibit the inclusion of getopt.h without an actual use. |
| sc_prohibit_getopt_without_use: |
| @h='<getopt.h>' re='\<getopt(_long)? *\(' $(_sc_header_without_use) |
| |
| # Don't include quotearg.h unless you use one of its functions. |
| sc_prohibit_quotearg_without_use: |
| @h='"quotearg.h"' re='\<quotearg(_[^ ]+)? *\(' $(_sc_header_without_use) |
| |
| # Don't include quote.h unless you use one of its functions. |
| sc_prohibit_quote_without_use: |
| @h='"quote.h"' re='\<quote(_n)? *\(' $(_sc_header_without_use) |
| |
| # Don't include this header unless you use one of its functions. |
| sc_prohibit_long_options_without_use: |
| @h='"long-options.h"' re='\<parse_long_options *\(' \ |
| $(_sc_header_without_use) |
| |
| # Don't include this header unless you use one of its functions. |
| sc_prohibit_inttostr_without_use: |
| @h='"inttostr.h"' re='\<(off|[iu]max|uint)tostr *\(' \ |
| $(_sc_header_without_use) |
| |
| # Don't include this header unless you use one of its functions. |
| sc_prohibit_ignore_value_without_use: |
| @h='"ignore-value.h"' re='\<ignore_(value|ptr) *\(' \ |
| $(_sc_header_without_use) |
| |
| # Don't include this header unless you use one of its functions. |
| sc_prohibit_error_without_use: |
| @h='"error.h"' \ |
| re='\<error(_at_line|_print_progname|_one_per_line|_message_count)? *\('\ |
| $(_sc_header_without_use) |
| |
| # Don't include xalloc.h unless you use one of its functions. |
| # Consider these symbols: |
| # perl -lne '/^# *define (\w+)\(/ and print $1' lib/xalloc.h|grep -v '^__'; |
| # perl -lne '/^(?:extern )?(?:void|char) \*?(\w+) *\(/ and print $1' lib/xalloc.h |
| # Divide into two sets on case, and filter each through this: |
| # | sort | perl -MRegexp::Assemble -le \ |
| # 'print Regexp::Assemble->new(file => "/dev/stdin")->as_string'|sed 's/\?://g' |
| # Note this was produced by the above: |
| # _xa1 = \ |
| #x(((2n?)?re|c(har)?|n(re|m)|z)alloc|alloc_(oversized|die)|m(alloc|emdup)|strdup) |
| # But we can do better, in at least two ways: |
| # 1) take advantage of two "dup"-suffixed strings: |
| # x(((2n?)?re|c(har)?|n(re|m)|[mz])alloc|alloc_(oversized|die)|(mem|str)dup) |
| # 2) notice that "c(har)?|[mz]" is equivalent to the shorter and more readable |
| # "char|[cmz]" |
| # x(((2n?)?re|char|n(re|m)|[cmz])alloc|alloc_(oversized|die)|(mem|str)dup) |
| _xa1 = x(((2n?)?re|char|n(re|m)|[cmz])alloc|alloc_(oversized|die)|(mem|str)dup) |
| _xa2 = X([CZ]|N?M)ALLOC |
| sc_prohibit_xalloc_without_use: |
| @h='"xalloc.h"' \ |
| re='\<($(_xa1)|$(_xa2)) *\('\ |
| $(_sc_header_without_use) |
| |
| # Extract function names: |
| # perl -lne '/^(?:extern )?(?:void|char) \*?(\w+) *\(/ and print $1' lib/hash.h |
| _hash_re = \ |
| clear|delete|free|get_(first|next)|insert|lookup|print_statistics|reset_tuning |
| _hash_fn = \<($(_hash_re)) *\( |
| _hash_struct = (struct )?\<[Hh]ash_(table|tuning)\> |
| sc_prohibit_hash_without_use: |
| @h='"hash.h"' \ |
| re='$(_hash_fn)|$(_hash_struct)'\ |
| $(_sc_header_without_use) |
| |
| sc_prohibit_hash_pjw_without_use: |
| @h='"hash-pjw.h"' \ |
| re='\<hash_pjw *\(' \ |
| $(_sc_header_without_use) |
| |
| sc_prohibit_safe_read_without_use: |
| @h='"safe-read.h"' re='(\<SAFE_READ_ERROR\>|\<safe_read *\()' \ |
| $(_sc_header_without_use) |
| |
| sc_prohibit_argmatch_without_use: |
| @h='"argmatch.h"' \ |
| re='(\<(ARRAY_CARDINALITY|X?ARGMATCH(|_TO_ARGUMENT|_VERIFY))\>|\<argmatch(_exit_fn|_(in)?valid) *\()' \ |
| $(_sc_header_without_use) |
| |
| sc_prohibit_canonicalize_without_use: |
| @h='"canonicalize.h"' \ |
| re='CAN_(EXISTING|ALL_BUT_LAST|MISSING)|canonicalize_(mode_t|filename_mode)' \ |
| $(_sc_header_without_use) |
| |
| sc_prohibit_root_dev_ino_without_use: |
| @h='"root-dev-ino.h"' \ |
| re='(\<ROOT_DEV_INO_(CHECK|WARN)\>|\<get_root_dev_ino *\()' \ |
| $(_sc_header_without_use) |
| |
| sc_prohibit_openat_without_use: |
| @h='"openat.h"' \ |
| re='\<(openat_(permissive|needs_fchdir|(save|restore)_fail)|l?(stat|ch(own|mod))at|(euid)?accessat)\>' \ |
| $(_sc_header_without_use) |
| |
| # Prohibit the inclusion of c-ctype.h without an actual use. |
| ctype_re = isalnum|isalpha|isascii|isblank|iscntrl|isdigit|isgraph|islower\ |
| |isprint|ispunct|isspace|isupper|isxdigit|tolower|toupper |
| sc_prohibit_c_ctype_without_use: |
| @h='[<"]c-ctype.h[">]' re='\<c_($(ctype_re)) *\(' \ |
| $(_sc_header_without_use) |
| |
| _empty = |
| _sp = $(_empty) $(_empty) |
| # The following list was generated by running: |
| # man signal.h|col -b|perl -ne '/bsd_signal.*;/.../sigwaitinfo.*;/ and print' \ |
| # | perl -lne '/^\s+(?:int|void).*?(\w+).*/ and print $1' | fmt |
| _sig_functions = \ |
| bsd_signal kill killpg pthread_kill pthread_sigmask raise sigaction \ |
| sigaddset sigaltstack sigdelset sigemptyset sigfillset sighold sigignore \ |
| siginterrupt sigismember signal sigpause sigpending sigprocmask sigqueue \ |
| sigrelse sigset sigsuspend sigtimedwait sigwait sigwaitinfo |
| _sig_function_re = $(subst $(_sp),|,$(strip $(_sig_functions))) |
| # The following were extracted from "man signal.h" manually. |
| _sig_types_and_consts = \ |
| MINSIGSTKSZ SA_NOCLDSTOP SA_NOCLDWAIT SA_NODEFER SA_ONSTACK \ |
| SA_RESETHAND SA_RESTART SA_SIGINFO SIGEV_NONE SIGEV_SIGNAL \ |
| SIGEV_THREAD SIGSTKSZ SIG_BLOCK SIG_SETMASK SIG_UNBLOCK SS_DISABLE \ |
| SS_ONSTACK mcontext_t pid_t sig_atomic_t sigevent siginfo_t sigset_t \ |
| sigstack sigval stack_t ucontext_t |
| # generated via this: |
| # perl -lne '/^#ifdef (SIG\w+)/ and print $1' lib/sig2str.c|sort -u|fmt -70 |
| _sig_names = \ |
| SIGABRT SIGALRM SIGALRM1 SIGBUS SIGCANCEL SIGCHLD SIGCLD SIGCONT \ |
| SIGDANGER SIGDIL SIGEMT SIGFPE SIGFREEZE SIGGRANT SIGHUP SIGILL \ |
| SIGINFO SIGINT SIGIO SIGIOT SIGKAP SIGKILL SIGKILLTHR SIGLOST SIGLWP \ |
| SIGMIGRATE SIGMSG SIGPHONE SIGPIPE SIGPOLL SIGPRE SIGPROF SIGPWR \ |
| SIGQUIT SIGRETRACT SIGSAK SIGSEGV SIGSOUND SIGSTKFLT SIGSTOP SIGSYS \ |
| SIGTERM SIGTHAW SIGTRAP SIGTSTP SIGTTIN SIGTTOU SIGURG SIGUSR1 \ |
| SIGUSR2 SIGVIRT SIGVTALRM SIGWAITING SIGWINCH SIGWIND SIGWINDOW \ |
| SIGXCPU SIGXFSZ |
| _sig_syms_re = $(subst $(_sp),|,$(strip $(_sig_names) $(_sig_types_and_consts))) |
| |
| # Prohibit the inclusion of signal.h without an actual use. |
| sc_prohibit_signal_without_use: |
| @h='<signal.h>' \ |
| re='\<($(_sig_function_re)) *\(|\<($(_sig_syms_re))\>' \ |
| $(_sc_header_without_use) |
| |
| # Prohibit the inclusion of strings.h without a sensible use. |
| # Using the likes of bcmp, bcopy, bzero, index or rindex is not sensible. |
| sc_prohibit_strings_without_use: |
| @h='<strings.h>' \ |
| re='\<(strn?casecmp|ffs(ll)?)\>' \ |
| $(_sc_header_without_use) |
| |
| # Get the list of symbol names with this: |
| # perl -lne '/^# *define (\w+)\(/ and print $1' lib/intprops.h|grep -v '^s'|fmt |
| _intprops_names = \ |
| TYPE_IS_INTEGER TYPE_TWOS_COMPLEMENT TYPE_ONES_COMPLEMENT \ |
| TYPE_SIGNED_MAGNITUDE TYPE_SIGNED TYPE_MINIMUM TYPE_MAXIMUM \ |
| INT_STRLEN_BOUND INT_BUFSIZE_BOUND |
| _intprops_syms_re = $(subst $(_sp),|,$(strip $(_intprops_names))) |
| # Prohibit the inclusion of intprops.h without an actual use. |
| sc_prohibit_intprops_without_use: |
| @h='"intprops.h"' \ |
| re='\<($(_intprops_syms_re)) *\(' \ |
| $(_sc_header_without_use) |
| |
| sc_obsolete_symbols: |
| @prohibit='\<(HAVE''_FCNTL_H|O''_NDELAY)\>' \ |
| halt='do not use HAVE''_FCNTL_H or O'_NDELAY \ |
| $(_sc_search_regexp) |
| |
| # FIXME: warn about definitions of EXIT_FAILURE, EXIT_SUCCESS, STREQ |
| |
| # Each nonempty ChangeLog line must start with a year number, or a TAB. |
| sc_changelog: |
| @prohibit='^[^12 ]' \ |
| in_vc_files='^ChangeLog$$' \ |
| halt='found unexpected prefix in a ChangeLog' \ |
| $(_sc_search_regexp) |
| |
| # Ensure that each .c file containing a "main" function also |
| # calls set_program_name. |
| sc_program_name: |
| @require='set_program_name *\(m?argv\[0\]\);' \ |
| in_vc_files='\.c$$' \ |
| containing='\<main *(' \ |
| halt='the above files do not call set_program_name' \ |
| $(_sc_search_regexp) |
| |
| # Ensure that each .c file containing a "main" function also |
| # calls bindtextdomain. |
| sc_bindtextdomain: |
| @require='bindtextdomain *\(' \ |
| in_vc_files='\.c$$' \ |
| containing='\<main *(' \ |
| halt='the above files do not call bindtextdomain' \ |
| $(_sc_search_regexp) |
| |
| # Require that the final line of each test-lib.sh-using test be this one: |
| # Exit $fail |
| # Note: this test requires GNU grep's --label= option. |
| Exit_witness_file ?= tests/test-lib.sh |
| Exit_base := $(notdir $(Exit_witness_file)) |
| sc_require_test_exit_idiom: |
| @if test -f $(srcdir)/$(Exit_witness_file); then \ |
| die=0; \ |
| for i in $$(grep -l -F 'srcdir/$(Exit_base)' \ |
| $$($(VC_LIST) tests)); do \ |
| tail -n1 $$i | grep '^Exit .' > /dev/null \ |
| && : || { die=1; echo $$i; } \ |
| done; \ |
| test $$die = 1 && \ |
| { echo 1>&2 '$(ME): the final line in each of the above is not:'; \ |
| echo 1>&2 'Exit something'; \ |
| exit 1; } || :; \ |
| fi |
| |
| sc_the_the: |
| @prohibit='\<the ''the\>' \ |
| ignore_case=1 \ |
| halt='found use of "the ''the";' \ |
| $(_sc_search_regexp) |
| |
| sc_trailing_blank: |
| @prohibit='[ ]$$' \ |
| halt='found trailing blank(s)' \ |
| $(_sc_search_regexp) |
| |
| # Match lines like the following, but where there is only one space |
| # between the options and the description: |
| # -D, --all-repeated[=delimit-method] print all duplicate lines\n |
| longopt_re = --[a-z][0-9A-Za-z-]*(\[?=[0-9A-Za-z-]*\]?)? |
| sc_two_space_separator_in_usage: |
| @prohibit='^ *(-[A-Za-z],)? $(longopt_re) [^ ].*\\$$' \ |
| halt='help2man requires at least two spaces between an option and its description'\ |
| $(_sc_search_regexp) |
| |
| # Look for diagnostics that aren't marked for translation. |
| # This won't find any for which error's format string is on a separate line. |
| sc_unmarked_diagnostics: |
| @grep -nE \ |
| '\<error *\([^"]*"[^"]*[a-z]{3}' $$($(VC_LIST_EXCEPT)) \ |
| | grep -v '_''(' && \ |
| { echo '$(ME): found unmarked diagnostic(s)' 1>&2; \ |
| exit 1; } || : |
| |
| # Avoid useless parentheses like those in this example: |
| # #if defined (SYMBOL) || defined (SYM2) |
| sc_useless_cpp_parens: |
| @prohibit='^# *if .*defined *\(' \ |
| halt='found useless parentheses in cpp directive' \ |
| $(_sc_search_regexp) |
| |
| # List headers for which HAVE_HEADER_H is always true, assuming you are |
| # using the appropriate gnulib module. CAUTION: for each "unnecessary" |
| # #if HAVE_HEADER_H that you remove, be sure that your project explicitly |
| # requires the gnulib module that guarantees the usability of that header. |
| gl_assured_headers_ = \ |
| cd $(gnulib_dir)/lib && echo *.in.h|sed 's/\.in\.h//g' |
| |
| # Convert the list of names to upper case, and replace each space with "|". |
| az_ = abcdefghijklmnopqrstuvwxyz |
| AZ_ = ABCDEFGHIJKLMNOPQRSTUVWXYZ |
| gl_header_upper_case_or_ = \ |
| $$($(gl_assured_headers_) \ |
| | tr $(az_)/.- $(AZ_)___ \ |
| | tr -s ' ' '|' \ |
| ) |
| sc_prohibit_always_true_header_tests: |
| @or=$(gl_header_upper_case_or_); \ |
| re="HAVE_($$or)_H"; \ |
| prohibit='\<'"$$re"'\>' \ |
| halt=$$(printf '%s\n' \ |
| 'do not test the above HAVE_<header>_H symbol(s);' \ |
| ' with the corresponding gnulib module, they are always true') \ |
| $(_sc_search_regexp) |
| |
| # ================================================================== |
| gl_other_headers_ ?= \ |
| intprops.h \ |
| openat.h \ |
| stat-macros.h |
| |
| # Perl -lne code to extract "significant" cpp-defined symbols from a |
| # gnulib header file, eliminating a few common false-positives. |
| gl_extract_significant_defines_ = \ |
| /^\# *define ([^_ (][^ (]*)(\s*\(|\s+\w+)/\ |
| && $$2 !~ /(?:rpl_|_used_without_)/\ |
| && $$1 !~ /^(?:NSIG|ATTRIBUTE_NORETURN)$$/\ |
| and print $$1 |
| |
| # Create a list of regular expressions matching the names |
| # of macros that are guaranteed to be defined by parts of gnulib. |
| define def_sym_regex |
| gen_h=$(gl_generated_headers_); \ |
| (cd $(gnulib_dir)/lib; \ |
| for f in *.in.h $(gl_other_headers_); do \ |
| perl -lne '$(gl_extract_significant_defines_)' $$f; \ |
| done; \ |
| ) | sort -u \ |
| | grep -Ev '^ATTRIBUTE_NORETURN' \ |
| | sed 's/^/^ *# *(define|undef) */;s/$$/\\>/' |
| endef |
| |
| # Don't define macros that we already get from gnulib header files. |
| sc_prohibit_always-defined_macros: |
| @if test -d $(gnulib_dir); then \ |
| case $$(echo all: | grep -l -f - Makefile) in Makefile);; *) \ |
| echo '$(ME): skipping $@: you lack GNU grep' 1>&2; exit 0;; \ |
| esac; \ |
| $(def_sym_regex) | grep -E -f - $$($(VC_LIST_EXCEPT)) \ |
| && { echo '$(ME): define the above via some gnulib .h file' \ |
| 1>&2; exit 1; } || :; \ |
| fi |
| # ================================================================== |
| |
| # Prohibit checked in backup files. |
| sc_prohibit_backup_files: |
| @$(VC_LIST) | grep '~$$' && \ |
| { echo '$(ME): found version controlled backup file' 1>&2; \ |
| exit 1; } || : |
| |
| # Require the latest GPL. |
| sc_GPL_version: |
| @prohibit='either ''version [^3]' \ |
| halt='GPL vN, N!=3' \ |
| $(_sc_search_regexp) |
| |
| # Require the latest GFDL. Two regexp, since some .texi files end up |
| # line wrapping between 'Free Documentation License,' and 'Version'. |
| _GFDL_regexp = (Free ''Documentation.*Version 1\.[^3]|Version 1\.[^3] or any) |
| sc_GFDL_version: |
| @prohibit='$(_GFDL_regexp)' \ |
| halt='GFDL vN, N!=3' \ |
| $(_sc_search_regexp) |
| |
| # Don't use Texinfo's @acronym{}. |
| # http://lists.gnu.org/archive/html/bug-gnulib/2010-03/msg00321.html |
| texinfo_suffix_re_ ?= \.(txi|texi(nfo)?)$$ |
| sc_texinfo_acronym: |
| @prohibit='@acronym\{' \ |
| in_vc_files='$(texinfo_suffix_re_)' \ |
| halt='found use of Texinfo @acronym{}' \ |
| $(_sc_search_regexp) |
| |
| cvs_keywords = \ |
| Author|Date|Header|Id|Name|Locker|Log|RCSfile|Revision|Source|State |
| |
| sc_prohibit_cvs_keyword: |
| @prohibit='\$$($(cvs_keywords))\$$' \ |
| halt='do not use CVS keyword expansion' \ |
| $(_sc_search_regexp) |
| |
| # This Perl code is slightly obfuscated. Not only is each "$" doubled |
| # because it's in a Makefile, but the $$c's are comments; we cannot |
| # use "#" due to the way the script ends up concatenated onto one line. |
| # It would be much more concise, and would produce better output (including |
| # counts) if written as: |
| # perl -ln -0777 -e '/\n(\n+)$/ and print "$ARGV: ".length $1' ... |
| # but that would be far less efficient, reading the entire contents |
| # of each file, rather than just the last two bytes of each. |
| # |
| # This is a perl script that is expected to be the single-quoted argument |
| # to a command-line "-le". The remaining arguments are file names. |
| # Print the name of each file that ends in two or more newline bytes. |
| # Exit nonzero if at least one such file is found, otherwise, exit 0. |
| # Warn about, but otherwise ignore open failure. Ignore seek/read failure. |
| # |
| # Use this if you want to remove trailing empty lines from selected files: |
| # perl -pi -0777 -e 's/\n\n+$/\n/' files... |
| # |
| detect_empty_lines_at_EOF_ = \ |
| foreach my $$f (@ARGV) \ |
| { \ |
| open F, "<", $$f or (warn "failed to open $$f: $$!\n"), next; \ |
| my $$p = sysseek (F, -2, 2); \ |
| my $$c = "seek failure probably means file has < 2 bytes; ignore"; \ |
| my $$last_two_bytes; \ |
| defined $$p and $$p = sysread F, $$last_two_bytes, 2; \ |
| close F; \ |
| $$c = "ignore read failure"; \ |
| $$p && $$last_two_bytes eq "\n\n" and (print $$f), $$fail=1; \ |
| } \ |
| END { exit defined $$fail } |
| sc_prohibit_empty_lines_at_EOF: |
| @perl -le '$(detect_empty_lines_at_EOF_)' $$($(VC_LIST_EXCEPT)) \ |
| || { echo '$(ME): the above files end with empty line(s)' \ |
| 1>&2; exit 1; } || :; \ |
| |
| # Make sure we don't use st_blocks. Use ST_NBLOCKS instead. |
| # This is a bit of a kludge, since it prevents use of the string |
| # even in comments, but for now it does the job with no false positives. |
| sc_prohibit_stat_st_blocks: |
| @prohibit='[.>]st_blocks' \ |
| halt='do not use st_blocks; use ST_NBLOCKS' \ |
| $(_sc_search_regexp) |
| |
| # Make sure we don't define any S_IS* macros in src/*.c files. |
| # They're already defined via gnulib's sys/stat.h replacement. |
| sc_prohibit_S_IS_definition: |
| @prohibit='^ *# *define *S_IS' \ |
| halt='do not define S_IS* macros; include <sys/stat.h>' \ |
| $(_sc_search_regexp) |
| |
| _ptm1 = use "test C1 && test C2", not "test C1 -''a C2" |
| _ptm2 = use "test C1 || test C2", not "test C1 -''o C2" |
| # Using test's -a and -o operators is not portable. |
| # We prefer test over [, since the latter is spelled [[ in configure.ac. |
| sc_prohibit_test_minus_ao: |
| @prohibit='(\<test| \[+) .+ -[ao] ' \ |
| halt='$(_ptm1); $(_ptm2)' \ |
| $(_sc_search_regexp) |
| |
| # Avoid a test bashism. |
| sc_prohibit_test_double_equal: |
| @prohibit='(\<test| \[+) .+ == ' \ |
| containing='#! */bin/[a-z]*sh' \ |
| halt='use "test x = x", not "test x =''= x"' \ |
| $(_sc_search_regexp) |
| |
| # Each program that uses proper_name_utf8 must link with one of the |
| # ICONV libraries. Otherwise, some ICONV library must appear in LDADD. |
| # The perl -0777 invocation below extracts the possibly-multi-line |
| # definition of LDADD from the appropriate Makefile.am and exits 0 |
| # when it contains "ICONV". |
| sc_proper_name_utf8_requires_ICONV: |
| @progs=$$(grep -l 'proper_name_utf8 ''("' $$($(VC_LIST_EXCEPT)));\ |
| if test "x$$progs" != x; then \ |
| fail=0; \ |
| for p in $$progs; do \ |
| dir=$$(dirname "$$p"); \ |
| perl -0777 \ |
| -ne 'exit !(/^LDADD =(.+?[^\\]\n)/ms && $$1 =~ /ICONV/)' \ |
| $$dir/Makefile.am && continue; \ |
| base=$$(basename "$$p" .c); \ |
| grep "$${base}_LDADD.*ICONV)" $$dir/Makefile.am > /dev/null \ |
| || { fail=1; echo 1>&2 "$(ME): $$p uses proper_name_utf8"; }; \ |
| done; \ |
| test $$fail = 1 && \ |
| { echo 1>&2 '$(ME): the above do not link with any ICONV library'; \ |
| exit 1; } || :; \ |
| fi |
| |
| # Warn about "c0nst struct Foo const foo[]", |
| # but not about "char const *const foo" or "#define const const". |
| sc_redundant_const: |
| @prohibit='\bconst\b[[:space:][:alnum:]]{2,}\bconst\b' \ |
| halt='redundant "const" in declarations' \ |
| $(_sc_search_regexp) |
| |
| sc_const_long_option: |
| @grep '^ *static.*struct option ' $$($(VC_LIST_EXCEPT)) \ |
| | grep -Ev 'const struct option|struct option const' && { \ |
| echo 1>&2 '$(ME): add "const" to the above declarations'; \ |
| exit 1; } || : |
| |
| NEWS_hash = \ |
| $$(sed -n '/^\*.* $(PREV_VERSION_REGEXP) ([0-9-]*)/,$$p' \ |
| $(srcdir)/NEWS \ |
| | perl -0777 -pe \ |
| 's/^Copyright.+?Free\sSoftware\sFoundation,\sInc\.\n//ms' \ |
| | md5sum - \ |
| | sed 's/ .*//') |
| |
| # Ensure that we don't accidentally insert an entry into an old NEWS block. |
| sc_immutable_NEWS: |
| @if test -f $(srcdir)/NEWS; then \ |
| test "$(NEWS_hash)" = '$(old_NEWS_hash)' && : || \ |
| { echo '$(ME): you have modified old NEWS' 1>&2; exit 1; }; \ |
| fi |
| |
| # Update the hash stored above. Do this after each release and |
| # for any corrections to old entries. |
| update-NEWS-hash: NEWS |
| perl -pi -e 's/^(old_NEWS_hash[ \t]+:?=[ \t]+).*/$${1}'"$(NEWS_hash)/" \ |
| $(srcdir)/cfg.mk |
| |
| # Ensure that we use only the standard $(VAR) notation, |
| # not @...@ in Makefile.am, now that we can rely on automake |
| # to emit a definition for each substituted variable. |
| # We use perl rather than "grep -nE ..." to exempt a single |
| # use of an @...@-delimited variable name in src/Makefile.am. |
| # Allow the package to add exceptions via a hook in cfg.mk; |
| # for example, @PRAGMA_SYSTEM_HEADER@ can be permitted by |
| # setting this to ' && !/PRAGMA_SYSTEM_HEADER/'. |
| _makefile_at_at_check_exceptions ?= |
| sc_makefile_at_at_check: |
| @perl -ne '/\@[A-Z_0-9]+\@/'$(_makefile_at_at_check_exceptions) \ |
| -e 'and (print "$$ARGV:$$.: $$_"), $$m=1; END {exit !$$m}' \ |
| $$($(VC_LIST_EXCEPT) | grep -E '(^|/)Makefile\.am$$') \ |
| && { echo '$(ME): use $$(...), not @...@' 1>&2; exit 1; } || : |
| |
| news-check: NEWS |
| if sed -n $(news-check-lines-spec)p $(srcdir)/NEWS \ |
| | grep -E $(news-check-regexp) >/dev/null; then \ |
| :; \ |
| else \ |
| echo 'NEWS: $$(news-check-regexp) failed to match' 1>&2; \ |
| exit 1; \ |
| fi |
| |
| sc_makefile_TAB_only_indentation: |
| @prohibit='^ [ ]{8}' \ |
| in_vc_files='akefile|\.mk$$' \ |
| halt='found TAB-8-space indentation' \ |
| $(_sc_search_regexp) |
| |
| sc_m4_quote_check: |
| @prohibit='(AC_DEFINE(_UNQUOTED)?|AC_DEFUN)\([^[]' \ |
| in_vc_files='(^configure\.ac|\.m4)$$' \ |
| halt='quote the first arg to AC_DEF*' \ |
| $(_sc_search_regexp) |
| |
| fix_po_file_diag = \ |
| 'you have changed the set of files with translatable diagnostics;\n\ |
| apply the above patch\n' |
| |
| # Verify that all source files using _() are listed in po/POTFILES.in. |
| po_file = po/POTFILES.in |
| sc_po_check: |
| @if test -f $(po_file); then \ |
| grep -E -v '^(#|$$)' $(po_file) \ |
| | grep -v '^src/false\.c$$' | sort > $@-1; \ |
| files=; \ |
| for file in $$($(VC_LIST_EXCEPT)) lib/*.[ch]; do \ |
| test -r $$file || continue; \ |
| case $$file in \ |
| *.m4|*.mk) continue ;; \ |
| *.?|*.??) ;; \ |
| *) continue;; \ |
| esac; \ |
| case $$file in \ |
| *.[ch]) \ |
| base=`expr " $$file" : ' \(.*\)\..'`; \ |
| { test -f $$base.l || test -f $$base.y; } && continue;; \ |
| esac; \ |
| files="$$files $$file"; \ |
| done; \ |
| grep -E -l '\b(N?_|gettext *)\([^)"]*("|$$)' $$files \ |
| | sort -u > $@-2; \ |
| diff -u -L $(po_file) -L $(po_file) $@-1 $@-2 \ |
| || { printf '$(ME): '$(fix_po_file_diag) 1>&2; exit 1; }; \ |
| rm -f $@-1 $@-2; \ |
| fi |
| |
| # Sometimes it is useful to change the PATH environment variable |
| # in Makefiles. When doing so, it's better not to use the Unix-centric |
| # path separator of `:', but rather the automake-provided `$(PATH_SEPARATOR)'. |
| msg = '$(ME): Do not use `:'\'' above; use $$(PATH_SEPARATOR) instead' |
| sc_makefile_path_separator_check: |
| @prohibit='PATH[=].*:' \ |
| in_vc_files='akefile|\.mk$$' \ |
| halt=$(msg) \ |
| $(_sc_search_regexp) |
| |
| # Check that `make alpha' will not fail at the end of the process. |
| writable-files: |
| if test -d $(release_archive_dir); then :; else \ |
| for file in $(distdir).tar.gz \ |
| $(release_archive_dir)/$(distdir).tar.gz; do \ |
| test -e $$file || continue; \ |
| test -w $$file \ |
| || { echo ERROR: $$file is not writable; fail=1; }; \ |
| done; \ |
| test "$$fail" && exit 1 || : ; \ |
| fi |
| |
| v_etc_file = $(gnulib_dir)/lib/version-etc.c |
| sample-test = tests/sample-test |
| texi = doc/$(PACKAGE).texi |
| # Make sure that the copyright date in $(v_etc_file) is up to date. |
| # Do the same for the $(sample-test) and the main doc/.texi file. |
| sc_copyright_check: |
| @require='enum { COPYRIGHT_YEAR = '$$(date +%Y)' };' \ |
| in_files=$(v_etc_file) \ |
| halt='out of date copyright in $(v_etc_file); update it' \ |
| $(_sc_search_regexp) |
| @require='# Copyright \(C\) '$$(date +%Y)' Free' \ |
| in_vc_files=$(sample-test) \ |
| halt='out of date copyright in $(sample-test); update it' \ |
| $(_sc_search_regexp) |
| @require='Copyright @copyright\{\} .*'$$(date +%Y)' Free' \ |
| in_vc_files=$(texi) \ |
| halt='out of date copyright in $(texi); update it' \ |
| $(_sc_search_regexp) |
| |
| # If tests/help-version exists and seems to be new enough, assume that its |
| # use of init.sh and path_prepend_ is correct, and ensure that every other |
| # use of init.sh is identical. |
| # This is useful because help-version cross-checks prog --version |
| # with $(VERSION), which verifies that its path_prepend_ invocation |
| # sets PATH correctly. This is an inexpensive way to ensure that |
| # the other init.sh-using tests also get it right. |
| _hv_file ?= $(srcdir)/tests/help-version |
| _hv_regex_weak ?= ^ *\. .*/init\.sh" |
| _hv_regex_strong ?= ^ *\. "\$${srcdir=\.}/init\.sh" |
| sc_cross_check_PATH_usage_in_tests: |
| @if test -f $(_hv_file); then \ |
| grep -l 'VERSION mismatch' $(_hv_file) >/dev/null \ |
| || { echo "$@: skipped: no such file: $(_hv_file)" 1>&2; \ |
| exit 0; }; \ |
| grep -lE '$(_hv_regex_strong)' $(_hv_file) >/dev/null \ |
| || { echo "$@: $(_hv_file) lacks conforming use of init.sh" 1>&2; \ |
| exit 1; }; \ |
| good=$$(grep -E '$(_hv_regex_strong)' $(_hv_file)); \ |
| grep -LFx "$$good" \ |
| $$(grep -lE '$(_hv_regex_weak)' $$($(VC_LIST_EXCEPT))) \ |
| | grep . && \ |
| { echo "$(ME): the above files use path_prepend_ inconsistently" \ |
| 1>&2; exit 1; } || :; \ |
| fi |
| |
| # #if HAVE_... will evaluate to false for any non numeric string. |
| # That would be flagged by using -Wundef, however gnulib currently |
| # tests many undefined macros, and so we can't enable that option. |
| # So at least preclude common boolean strings as macro values. |
| sc_Wundef_boolean: |
| @prohibit='^#define.*(yes|no|true|false)$$' \ |
| in_files='$(CONFIG_INCLUDE)' \ |
| halt='Use 0 or 1 for macro values' \ |
| $(_sc_search_regexp) |
| |
| sc_vulnerable_makefile_CVE-2009-4029: |
| @prohibit='perm -777 -exec chmod a\+rwx|chmod 777 \$$\(distdir\)' \ |
| in_files=$$(find $(srcdir) -name Makefile.in) \ |
| halt=$$(printf '%s\n' \ |
| 'the above files are vulnerable; beware of running' \ |
| ' "make dist*" rules, and upgrade to fixed automake' \ |
| ' see http://bugzilla.redhat.com/542609 for details') \ |
| $(_sc_search_regexp) |
| |
| vc-diff-check: |
| (unset CDPATH; cd $(srcdir) && $(VC) diff) > vc-diffs || : |
| if test -s vc-diffs; then \ |
| cat vc-diffs; \ |
| echo "Some files are locally modified:" 1>&2; \ |
| exit 1; \ |
| else \ |
| rm vc-diffs; \ |
| fi |
| |
| rel-files = $(DIST_ARCHIVES) |
| |
| gnulib_dir ?= $(srcdir)/gnulib |
| gnulib-version = $$(cd $(gnulib_dir) && git describe) |
| bootstrap-tools ?= autoconf,automake,gnulib |
| |
| # If it's not already specified, derive the GPG key ID from |
| # the signed tag we've just applied to mark this release. |
| gpg_key_ID ?= \ |
| $$(git cat-file tag v$(VERSION) > .ann-sig \ |
| && gpgv .ann-sig - < /dev/null 2>&1 \ |
| | sed -n '/.*key ID \([0-9A-F]*\)/s//\1/p'; rm -f .ann-sig) |
| |
| translation_project_ ?= coordinator@translationproject.org |
| announcement_Cc_ ?= $(translation_project_), $(PACKAGE_BUGREPORT) |
| announcement_mail_headers_ ?= \ |
| To: info-gnu@gnu.org \ |
| Cc: $(announcement_Cc_) \ |
| Mail-Followup-To: $(PACKAGE_BUGREPORT) |
| |
| announcement: NEWS ChangeLog $(rel-files) |
| @$(build_aux)/announce-gen \ |
| --mail-headers='$(announcement_mail_headers_)' \ |
| --release-type=$(RELEASE_TYPE) \ |
| --package=$(PACKAGE) \ |
| --prev=$(PREV_VERSION) \ |
| --curr=$(VERSION) \ |
| --gpg-key-id=$(gpg_key_ID) \ |
| --news=$(srcdir)/NEWS \ |
| --bootstrap-tools=$(bootstrap-tools) \ |
| --gnulib-version=$(gnulib-version) \ |
| --no-print-checksums \ |
| $(addprefix --url-dir=, $(url_dir_list)) |
| |
| ## ---------------- ## |
| ## Updating files. ## |
| ## ---------------- ## |
| |
| ftp-gnu = ftp://ftp.gnu.org/gnu |
| www-gnu = http://www.gnu.org |
| |
| upload_dest_dir_ ?= $(PACKAGE) |
| emit_upload_commands: |
| @echo ===================================== |
| @echo ===================================== |
| @echo "$(build_aux)/gnupload $(GNUPLOADFLAGS) \\" |
| @echo " --to $(gnu_rel_host):$(upload_dest_dir_) \\" |
| @echo " $(rel-files)" |
| @echo '# send the ~/announce-$(my_distdir) e-mail' |
| @echo ===================================== |
| @echo ===================================== |
| |
| define emit-commit-log |
| printf '%s\n' 'post-release administrivia' '' \ |
| '* NEWS: Add header line for next release.' \ |
| '* .prev-version: Record previous version.' \ |
| '* cfg.mk (old_NEWS_hash): Auto-update.' |
| endef |
| |
| .PHONY: no-submodule-changes |
| no-submodule-changes: |
| if test -d $(srcdir)/.git; then \ |
| diff=$$(cd $(srcdir) && git submodule -q foreach \ |
| git diff-index --name-only HEAD) \ |
| || exit 1; \ |
| case $$diff in '') ;; \ |
| *) echo '$(ME): submodule files are locally modified:'; \ |
| echo "$$diff"; exit 1;; esac; \ |
| else \ |
| : ; \ |
| fi |
| |
| submodule-checks ?= no-submodule-changes public-submodule-commit |
| |
| # Ensure that each sub-module commit we're using is public. |
| # Without this, it is too easy to tag and release code that |
| # cannot be built from a fresh clone. |
| .PHONY: public-submodule-commit |
| public-submodule-commit: |
| if test -d $(srcdir)/.git; then \ |
| git submodule foreach 'test $$(git rev-parse origin)' \ |
| = '"$$(git merge-base --independent origin $$sha1)"' \ |
| || { echo '$(ME): found non-public submodule commit' >&2; \ |
| exit 1; }; \ |
| else \ |
| : ; \ |
| fi |
| |
| .PHONY: alpha beta stable |
| ALL_RECURSIVE_TARGETS += alpha beta stable |
| alpha beta stable: $(local-check) writable-files $(submodule-checks) |
| test $@ = stable \ |
| && { echo $(VERSION) | grep -E '^[0-9]+(\.[0-9]+)+$$' \ |
| || { echo "invalid version string: $(VERSION)" 1>&2; exit 1;};}\ |
| || : |
| $(MAKE) vc-diff-check |
| $(MAKE) news-check |
| $(MAKE) distcheck |
| $(MAKE) dist XZ_OPT=-9ev |
| $(MAKE) $(release-prep-hook) RELEASE_TYPE=$@ |
| $(MAKE) -s emit_upload_commands RELEASE_TYPE=$@ |
| |
| # Override this in cfg.mk if you follow different procedures. |
| release-prep-hook ?= release-prep |
| |
| gl_noteworthy_news_ = * Noteworthy changes in release ?.? (????-??-??) [?] |
| .PHONY: release-prep |
| release-prep: |
| case $$RELEASE_TYPE in alpha|beta|stable) ;; \ |
| *) echo "invalid RELEASE_TYPE: $$RELEASE_TYPE" 1>&2; exit 1;; esac |
| $(MAKE) -s announcement > ~/announce-$(my_distdir) |
| if test -d $(release_archive_dir); then \ |
| ln $(rel-files) $(release_archive_dir); \ |
| chmod a-w $(rel-files); \ |
| fi |
| echo $(VERSION) > $(prev_version_file) |
| $(MAKE) update-NEWS-hash |
| perl -pi -e '$$. == 3 and print "$(gl_noteworthy_news_)\n\n\n"' NEWS |
| $(emit-commit-log) > .ci-msg |
| $(VC) commit -F .ci-msg -a |
| rm .ci-msg |
| |
| # Override this with e.g., -s $(srcdir)/some_other_name.texi |
| # if the default $(PACKAGE)-derived name doesn't apply. |
| gendocs_options_ ?= |
| |
| .PHONY: web-manual |
| web-manual: |
| @test -z "$(manual_title)" \ |
| && { echo define manual_title in cfg.mk 1>&2; exit 1; } || : |
| @cd '$(srcdir)/doc'; \ |
| $(SHELL) ../build-aux/gendocs.sh $(gendocs_options_) \ |
| -o '$(abs_builddir)/doc/manual' \ |
| --email $(PACKAGE_BUGREPORT) $(PACKAGE) \ |
| "$(PACKAGE_NAME) - $(manual_title)" |
| @echo " *** Upload the doc/manual directory to web-cvs." |
| |
| # Code Coverage |
| |
| init-coverage: |
| $(MAKE) $(AM_MAKEFLAGS) clean |
| lcov --directory . --zerocounters |
| |
| COVERAGE_CCOPTS ?= "-g --coverage" |
| COVERAGE_OUT ?= doc/coverage |
| |
| build-coverage: |
| $(MAKE) $(AM_MAKEFLAGS) CFLAGS=$(COVERAGE_CCOPTS) CXXFLAGS=$(COVERAGE_CCOPTS) |
| $(MAKE) $(AM_MAKEFLAGS) CFLAGS=$(COVERAGE_CCOPTS) CXXFLAGS=$(COVERAGE_CCOPTS) check |
| mkdir -p $(COVERAGE_OUT) |
| lcov --directory . --output-file $(COVERAGE_OUT)/$(PACKAGE).info \ |
| --capture |
| |
| gen-coverage: |
| genhtml --output-directory $(COVERAGE_OUT) \ |
| $(COVERAGE_OUT)/$(PACKAGE).info \ |
| --highlight --frames --legend \ |
| --title "$(PACKAGE_NAME)" |
| |
| coverage: init-coverage build-coverage gen-coverage |
| |
| # Update gettext files. |
| PACKAGE ?= $(shell basename $(PWD)) |
| PO_DOMAIN ?= $(PACKAGE) |
| POURL = http://translationproject.org/latest/$(PO_DOMAIN)/ |
| PODIR ?= po |
| refresh-po: |
| rm -f $(PODIR)/*.po && \ |
| echo "$(ME): getting translations into po (please ignore the robots.txt ERROR 404)..." && \ |
| wget --no-verbose --directory-prefix $(PODIR) --no-directories --recursive --level 1 --accept .po --accept .po.1 $(POURL) && \ |
| echo 'en@boldquot' > $(PODIR)/LINGUAS && \ |
| echo 'en@quot' >> $(PODIR)/LINGUAS && \ |
| ls $(PODIR)/*.po | sed 's/\.po//' | sed 's,$(PODIR)/,,' | sort >> $(PODIR)/LINGUAS |
| |
| # Running indent once is not idempotent, but running it twice is. |
| INDENT_SOURCES ?= $(C_SOURCES) |
| .PHONY: indent |
| indent: |
| indent $(INDENT_SOURCES) |
| indent $(INDENT_SOURCES) |
| |
| # If you want to set UPDATE_COPYRIGHT_* environment variables, |
| # put the assignments in this variable. |
| update-copyright-env ?= |
| |
| # Run this rule once per year (usually early in January) |
| # to update all FSF copyright year lists in your project. |
| # If you have an additional project-specific rule, |
| # add it in cfg.mk along with a line 'update-copyright: prereq'. |
| # By default, exclude all variants of COPYING; you can also |
| # add exemptions (such as ChangeLog..* for rotated change logs) |
| # in the file .x-update-copyright. |
| .PHONY: update-copyright |
| update-copyright: |
| grep -l -w Copyright \ |
| $$(export VC_LIST_EXCEPT_DEFAULT=COPYING && $(VC_LIST_EXCEPT)) \ |
| | $(update-copyright-env) xargs $(build_aux)/$@ |